package cn.com.qmth.stmms.biz.exam.bean;

import java.util.Date;

import cn.com.qmth.stmms.biz.mark.model.ArbitrateHistory;
import cn.com.qmth.stmms.common.annotation.ExcelField;
import cn.com.qmth.stmms.common.enums.HistoryStatus;
import io.swagger.annotations.ApiModelProperty;

/**
 * 多评仲裁记录表
 *
 */
public class ArbitrateHistoryVo {

    private Integer id;

    /**
     * 考试ID
     */
    private Integer examId;

    /**
     * 科目CODE
     */
    @ExcelField(title = "科目代码", align = 2, sort = 10)
    @ApiModelProperty("科目CODE")
    private String subjectCode;

    /**
     * 大题序号
     */
    @ExcelField(title = "分组序号", align = 2, sort = 20)
    @ApiModelProperty("分组序号")
    private Integer groupNumber;

    /**
     * 考生编号
     */
    private Integer studentId;

    /**
     * 准考证号
     */
    @ExcelField(title = "准考证号", align = 2, sort = 30)
    @ApiModelProperty("准考证号")
    private String examNumber;

    /**
     * 考生密号
     */
    private String secretNumber;

    /**
     * 仲裁处理用户ID
     */
    private Integer userId;

    /**
     * 仲裁给分总分
     */
    private Double totalScore;

    /**
     * 仲裁给分明细
     */
    private String scoreList;

    /**
     * 状态
     */
    @ApiModelProperty("状态")
    private HistoryStatus status;

    @ExcelField(title = "状态", align = 2, sort = 40)
    private String statusText;

    /**
     * 未作答的步骤数量
     */
    private Integer unansweredCount;

    /**
     * 创建时间
     */
    @ExcelField(title = "创建时间", align = 2, sort = 50)
    @ApiModelProperty("创建时间")
    private Date createTime;

    /**
     * 处理时间
     */
    @ExcelField(title = "处理时间", align = 2, sort = 60)
    @ApiModelProperty("处理时间")
    private Date updateTime;

    private String questionIndex;

    @ExcelField(title = "处理人", align = 2, sort = 70)
    @ApiModelProperty("处理人")
    private String arbitrateName;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public Integer getStudentId() {
        return studentId;
    }

    public void setStudentId(Integer studentId) {
        this.studentId = studentId;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getSecretNumber() {
        return secretNumber;
    }

    public void setSecretNumber(String secretNumber) {
        this.secretNumber = secretNumber;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public Double getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(Double totalScore) {
        this.totalScore = totalScore;
    }

    public String getScoreList() {
        return scoreList;
    }

    public void setScoreList(String scoreList) {
        this.scoreList = scoreList;
    }

    public HistoryStatus getStatus() {
        return status;
    }

    public void setStatus(HistoryStatus status) {
        this.status = status;
    }

    public String getStatusText() {
        return statusText;
    }

    public void setStatusText(String statusText) {
        this.statusText = statusText;
    }

    public Integer getUnansweredCount() {
        return unansweredCount;
    }

    public void setUnansweredCount(Integer unansweredCount) {
        this.unansweredCount = unansweredCount;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getQuestionIndex() {
        return questionIndex;
    }

    public void setQuestionIndex(String questionIndex) {
        this.questionIndex = questionIndex;
    }

    public String getArbitrateName() {
        return arbitrateName;
    }

    public void setArbitrateName(String arbitrateName) {
        this.arbitrateName = arbitrateName;
    }

    public static ArbitrateHistoryVo of(ArbitrateHistory from) {
        if (from == null) {
            return null;
        }
        ArbitrateHistoryVo ret = new ArbitrateHistoryVo();
        ret.setId(from.getId());
        ret.setExamId(from.getExamId());
        ret.setSubjectCode(from.getSubjectCode());
        ret.setGroupNumber(from.getGroupNumber());
        ret.setStudentId(from.getStudentId());
        ret.setExamNumber(from.getExamNumber());
        ret.setSecretNumber(from.getSecretNumber());
        ret.setUserId(from.getUserId());
        ret.setTotalScore(from.getTotalScore());
        ret.setScoreList(from.getScoreList());
        ret.setStatus(from.getStatus());
        ret.setStatusText(from.getStatus() == null ? null : from.getStatus().getName());
        ret.setUnansweredCount(from.getUnansweredCount());
        ret.setUpdateTime(from.getUpdateTime());
        ret.setCreateTime(from.getCreateTime());
        ret.setQuestionIndex(from.getQuestionIndex());
        if (from.getUser() != null) {
            ret.setArbitrateName(from.getUser().getLoginName() + "/" + from.getUser().getName());
        }
        return ret;
    }
}
