package cn.com.qmth.stmms.biz.exam.bean;

import java.util.Date;

import cn.com.qmth.stmms.biz.mark.model.ProblemHistory;
import cn.com.qmth.stmms.common.annotation.ExcelField;
import io.swagger.annotations.ApiModelProperty;

public class ProblemHistoryVo {

    private String subjectCode;

    private String subjectName;

    @ExcelField(title = "科目", align = 2, sort = 10)
    @ApiModelProperty("科目")
    private String subjectText;
    @ExcelField(title = "分组序号", align = 2, sort = 20)
    private Integer groupNumber;

    @ExcelField(title = "状态", align = 2, sort = 30)
    private String status;

    @ExcelField(title = "准考证号", align = 2, sort = 30)
    @ApiModelProperty("准考证号")
    private String examNumber;

    @ExcelField(title = "密号", align = 2, sort = 40)
    @ApiModelProperty("密号")
    private String secretNumber;

    @ExcelField(title = "姓名", align = 2, sort = 50)
    @ApiModelProperty("姓名")
    private String name;

    @ExcelField(title = "评卷员", align = 2, sort = 60)
    @ApiModelProperty("评卷员")
    private String markerName;


    @ApiModelProperty("提交时间")
    @ExcelField(title = "提交时间", align = 2, sort = 90)
    private Date createTime;

    @ExcelField(title = "类型", align = 2, sort = 100)
    private String problemType;

    @ExcelField(title = "处理人", align = 2, sort = 110)
    private String headerName;

    @ApiModelProperty("处理时间")
    @ExcelField(title = "处理时间", align = 2, sort = 120)
    private Date updateTime;

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectText() {
        return subjectText;
    }

    public void setSubjectText(String subjectText) {
        this.subjectText = subjectText;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getSecretNumber() {
        return secretNumber;
    }

    public void setSecretNumber(String secretNumber) {
        this.secretNumber = secretNumber;
    }


    public String getMarkerName() {
        return markerName;
    }

    public void setMarkerName(String markerName) {
        this.markerName = markerName;
    }


    public String getHeaderName() {
        return headerName;
    }

    public void setHeaderName(String headerName) {
        this.headerName = headerName;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getProblemType() {
        return problemType;
    }

    public void setProblemType(String problemType) {
        this.problemType = problemType;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public static ProblemHistoryVo of(ProblemHistory from) {
        if (from == null) {
            return null;
        }
        ProblemHistoryVo ret = new ProblemHistoryVo();
        ret.setSubjectCode(from.getSubjectCode());
        ret.setGroupNumber(from.getGroupNumber());
        ret.setExamNumber(from.getExamNumber());
        ret.setSecretNumber(from.getSecretNumber());
        ret.setStatus(from.getStatus().getName());
        ret.setCreateTime(from.getCreateTime());
        ret.setUpdateTime(from.getUpdateTime());
        return ret;
    }
}
